/**
 * Created with JetBrains WebStorm.
 * User: ge.jiang   feng.xiao
 * Date: 13-8-5
 * Time: 上午11:03
 * To change this template use File | Settings | File Templates.
 */

    var Matrix = {};

    Matrix.release = function () {
    };

    /**
     *
     * @param mat
     */
    Matrix.makeIdentity = function (mat) {
        mat[0] = 1;
        mat[1] = 0;
        mat[2] = 0;
        mat[3] = 0;
        mat[4] = 0;
        mat[5] = 1;
        mat[6] = 0;
        mat[7] = 0;
        mat[8] = 0;
        mat[9] = 0;
        mat[10] = 1;
        mat[11] = 0;
        mat[12] = 0;
        mat[13] = 0;
        mat[14] = 0;
        mat[15] = 1;
    };

    Matrix.create = function () {
        return [1, 0, 0, 0,
            0, 1, 0, 0,
            0, 0, 1, 0,
            0, 0, 0, 1];
    }

    /**
     *
     * @param array
     * @returns {{stack: Array, push: Function, pop: Function}}
     */
    Matrix.makeMatrixStack = function (array) {
        var stk = [];
        stk.top = 0;
        return {
            stack: stk,
            push: function () {
                var bt = this.stack;
                if (bt.top < bt.length) {
                    return bt[bt.top++];
                }
                var bu = new array(16);
                bt[bt.top] = bu;
                if (++bt.top > 100) {
                    console.log("error: matrix stack overflow!");
                }
                return bu;
            },
            pop: function () {
                if (--this.stack.top < 0) {
                    console.log("error: matrix stack underflow");
                }
            }
        };
    };

    /**
     * Matrix Multiply
     * @param { Matrix } retVal output matrix;
     * @param { Matrix } m1  input matrix1;
     * @param { Matrix } m2  input matrix2;
     */
    Matrix.multiply = function (retVal, m1, m2) {
        var M00 = m1[0], M01 = m1[1], M02 = m1[2], M03 = m1[3],
            M10 = m1[4], M11 = m1[5], M12 = m1[6], M13 = m1[7],
            M20 = m1[8], M21 = m1[9], M22 = m1[10], M23 = m1[11],
            M30 = m1[12], M31 = m1[13], M32 = m1[14], M33 = m1[15],

            n00 = m2[0], n01 = m2[1], n02 = m2[2], n03 = m2[3],
            n10 = m2[4], n11 = m2[5], n12 = m2[6], n13 = m2[7],
            n20 = m2[8], n21 = m2[9], n22 = m2[10], n23 = m2[11],
            n30 = m2[12], n31 = m2[13], n32 = m2[14], n33 = m2[15];

        retVal[0] = M00 * n00 + M01 * n10 + M02 * n20 + M03 * n30;
        retVal[1] = M00 * n01 + M01 * n11 + M02 * n21 + M03 * n31;
        retVal[2] = M00 * n02 + M01 * n12 + M02 * n22 + M03 * n32;
        retVal[3] = M00 * n03 + M01 * n13 + M02 * n23 + M03 * n33;

        retVal[4] = M10 * n00 + M11 * n10 + M12 * n20 + M13 * n30;
        retVal[5] = M10 * n01 + M11 * n11 + M12 * n21 + M13 * n31;
        retVal[6] = M10 * n02 + M11 * n12 + M12 * n22 + M13 * n32;
        retVal[7] = M10 * n03 + M11 * n13 + M12 * n23 + M13 * n33;

        retVal[8] = M20 * n00 + M21 * n10 + M22 * n20 + M23 * n30;
        retVal[9] = M20 * n01 + M21 * n11 + M22 * n21 + M23 * n31;
        retVal[10] = M20 * n02 + M21 * n12 + M22 * n22 + M23 * n32;
        retVal[11] = M20 * n03 + M21 * n13 + M22 * n23 + M23 * n33;

        retVal[12] = M30 * n00 + M31 * n10 + M32 * n20 + M33 * n30;
        retVal[13] = M30 * n01 + M31 * n11 + M32 * n21 + M33 * n31;
        retVal[14] = M30 * n02 + M31 * n12 + M32 * n22 + M33 * n32;
        retVal[15] = M30 * n03 + M31 * n13 + M32 * n23 + M33 * n33;
    };


    Matrix.lookatRH = function (retVal, position, target, up) {
        var xAxis = [0, 0, 0];
        var yAxis = [0, 0, 0];
        var zAxis = [0, 0, 0];

        Vector3.sub(zAxis, position, target);
        Vector3.normalize(zAxis, zAxis);

        Vector3.cross(xAxis, up, zAxis);
        Vector3.normalize(xAxis, xAxis)

        Vector3.cross(yAxis, zAxis, xAxis);
        Vector3.normalize(yAxis, yAxis);

        retVal[0] = xAxis[0], retVal[1] = yAxis[0], retVal[2] = zAxis[0], retVal[3] = 0;
        retVal[4] = xAxis[1], retVal[5] = yAxis[1], retVal[6] = zAxis[1], retVal[7] = 0;
        retVal[8] = xAxis[2], retVal[9] = yAxis[2], retVal[10] = zAxis[2], retVal[11] = 0;
        retVal[12] = -Vector3.dot(xAxis, position);
        retVal[13] = -Vector3.dot(yAxis, position);
        retVal[14] = -Vector3.dot(zAxis, position);
        retVal[15] = 1.0;
    };

    Matrix.perspectiveRH = function (retVal, fovy, aspect, zn, zf) {
        var tan_fovy = 1 / Math.tan(fovy * 0.5);
        retVal[0] = tan_fovy / aspect;
        retVal[1] = 0;
        retVal[2] = 0;
        retVal[3] = 0;
        retVal[4] = 0;
        retVal[5] = tan_fovy;
        retVal[6] = 0;
        retVal[7] = 0;
        retVal[8] = 0;
        retVal[9] = 0;
        retVal[10] = (zf + zn) / (zn - zf);
        retVal[11] = -1;
        retVal[12] = 0.0;
        retVal[13] = 0;
        retVal[14] = 2.0 * zn * zf / (zn - zf);
        retVal[15] = 0;
    };

    Matrix.orthoRH = function (retVal, w, h, zn, zf) {
        //var tan_fovy = 1 / Math.tan(fovy * 0.5);
        retVal[0] = 2 / w;
        retVal[1] = 0;
        retVal[2] = 0;
        retVal[3] = 0;
        retVal[4] = 0;
        retVal[5] = 2 / h;
        retVal[6] = 0;
        retVal[7] = 0;
        retVal[8] = 0;
        retVal[9] = 0;
        retVal[10] = 2.0 / (zn - zf);
        retVal[11] = 0;
        retVal[12] = 0.0;
        retVal[13] = 0;
        retVal[14] = (zf + zn) / (zn - zf);
        retVal[15] = 0;
    };

    Matrix.fromTNBP = function (retVal, xAxis, yAxis, zAxis, vecP) {
        retVal[0] = xAxis[0], retVal[1] = xAxis[1], retVal[2] = xAxis[2], retVal[3] = 0;
        retVal[4] = yAxis[0], retVal[5] = yAxis[1], retVal[6] = yAxis[2], retVal[7] = 0;
        retVal[8] = zAxis[0], retVal[9] = zAxis[1], retVal[10] = zAxis[2], retVal[11] = 0;
        retVal[12] = vecP[0], retVal[13] = vecP[1], retVal[14] = vecP[2], retVal[15] = 1;

        return retVal;
    };

    Matrix.translate = function (retVal, x, y, z) {
        retVal[0] = 1;
        retVal[1] = 0;
        retVal[2] = 0;
        retVal[3] = 0;
        retVal[4] = 0;
        retVal[5] = 1;
        retVal[6] = 0;
        retVal[7] = 0;
        retVal[8] = 0;
        retVal[9] = 0;
        retVal[10] = 1;
        retVal[11] = 0;
        retVal[12] = x;
        retVal[13] = y;
        retVal[14] = z;
        retVal[15] = 1;
    };

    Matrix.scale = function (retVal, x, y, z) {
        retVal[0] = x;
        retVal[1] = 0;
        retVal[2] = 0;
        retVal[3] = 0;
        retVal[4] = 0;
        retVal[5] = y;
        retVal[6] = 0;
        retVal[7] = 0;
        retVal[8] = 0;
        retVal[9] = 0;
        retVal[10] = z;
        retVal[11] = 0;
        retVal[12] = 0;
        retVal[13] = 0;
        retVal[14] = 0;
        retVal[15] = 1;
    };

    Matrix.rotateAxisX = function (retVal, angel) {
        var cos_angel = Math.cos(angel);
        var sin_angel = Math.sin(angel);
        retVal[0] = 1;
        retVal[1] = 0;
        retVal[2] = 0;
        retVal[3] = 0;
        retVal[4] = 0;
        retVal[5] = cos_angel;
        retVal[6] = sin_angel;
        retVal[7] = 0;
        retVal[8] = 0;
        retVal[9] = -sin_angel;
        retVal[10] = cos_angel;
        retVal[11] = 0;
        retVal[12] = 0;
        retVal[13] = 0;
        retVal[14] = 0;
        retVal[15] = 1;
    };

    Matrix.rotateAxisY = function (retVal, angel) {
        var cos_angel = Math.cos(angel);
        var sin_angel = Math.sin(angel);
        retVal[0] = cos_angel;
        retVal[1] = 0;
        retVal[2] = -sin_angel;
        retVal[3] = 0;
        retVal[4] = 0;
        retVal[5] = 0;
        retVal[6] = 0;
        retVal[7] = 0;
        retVal[8] = sin_angel;
        retVal[9] = 0;
        retVal[10] = cos_angel;
        retVal[11] = 0;
        retVal[12] = 0;
        retVal[13] = 0;
        retVal[14] = 0;
        retVal[15] = 1;
    };

    Matrix.rotateAxisZ = function (retVal, angel) {
        var cos_angel = Math.cos(angel);
        var sin_angel = Math.sin(angel);
        retVal[0] = cos_angel;
        retVal[1] = sin_angel;
        retVal[2] = 0;
        retVal[3] = 0;
        retVal[4] = -sin_angel;
        retVal[5] = cos_angel;
        retVal[6] = 0;
        retVal[7] = 0;
        retVal[8] = 0;
        retVal[9] = 0;
        retVal[10] = 1;
        retVal[11] = 0;
        retVal[12] = 0;
        retVal[13] = 0;
        retVal[14] = 0;
        retVal[15] = 1;
    };

    Matrix.rotateAxis = function (retVal, from, to, angel) {

    };

    Matrix.fromQuaternion = function (retVal, q) {
        var x = q[0], y = q[1], z = q[2], w = q[3];
        var xx = x * x;
        var xy = x * y;
        var xz = x * z;
        var xw = x * w;

        var yy = y * y;
        var yz = y * z;
        var yw = y * w;

        var zz = z * z;
        var zw = z * w;

        retVal[0] = 1 - 2 * ( yy + zz );
        retVal[1] = 2 * ( xy + zw );
        retVal[2] = 2 * ( xz - yw );

        retVal[4] = 2 * ( xy - zw );
        retVal[5] = 1 - 2 * ( xx + zz );
        retVal[6] = 2 * ( yz + xw );

        retVal[8] = 2 * ( xz + yw );
        retVal[9] = 2 * ( yz - xw );
        retVal[10] = 1 - 2 * ( xx + yy );

        retVal[3] = retVal[7] = retVal[11] = retVal[12] = retVal[13] = retVal[14] = 0;
        retVal[15] = 1;
    };

    Matrix.inverse = function (result, matrix) {
        var matrix0 = matrix[0];
        var matrix1 = matrix[1];
        var matrix2 = matrix[2];
        var matrix4 = matrix[4];
        var matrix5 = matrix[5];
        var matrix6 = matrix[6];
        var matrix8 = matrix[8];
        var matrix9 = matrix[9];
        var matrix10 = matrix[10];

        var vX = matrix[12];
        var vY = matrix[13];
        var vZ = matrix[14];

        var x = -matrix0 * vX - matrix1 * vY - matrix2 * vZ;
        var y = -matrix4 * vX - matrix5 * vY - matrix6 * vZ;
        var z = -matrix8 * vX - matrix9 * vY - matrix10 * vZ;

        result[0] = matrix0;
        result[1] = matrix4;
        result[2] = matrix8;
        result[3] = 0.0;
        result[4] = matrix1;
        result[5] = matrix5;
        result[6] = matrix9;
        result[7] = 0.0;
        result[8] = matrix2;
        result[9] = matrix6;
        result[10] = matrix10;
        result[11] = 0.0;
        result[12] = x;
        result[13] = y;
        result[14] = z;
        result[15] = 1.0;
        return result;
    };


    Matrix.transpose = function (mat) {
        var tmp = 0;
        tmp = mat[1];
        mat[1] = mat[4];
        mat[4] = tmp;
        tmp = mat[2];
        mat[2] = mat[8];
        mat[8] = tmp;
        tmp = mat[3];
        mat[3] = mat[12];
        mat[12] = tmp;
        tmp = mat[6];
        mat[6] = mat[9];
        mat[9] = tmp;
        tmp = mat[7];
        mat[7] = mat[13];
        mat[13] = tmp;
        tmp = mat[11];
        mat[11] = mat[14];
        mat[14] = tmp;
    };

    Matrix.clone = function (result, matrix) {
        result[0] = matrix[0];
        result[1] = matrix[1];
        result[2] = matrix[2];
        result[3] = matrix[3];
        result[4] = matrix[4];
        result[5] = matrix[5];
        result[6] = matrix[6];
        result[7] = matrix[7];
        result[8] = matrix[8];
        result[9] = matrix[9];
        result[10] = matrix[10];
        result[11] = matrix[11];
        result[12] = matrix[12];
        result[13] = matrix[13];
        result[14] = matrix[14];
        result[15] = matrix[15];
        return result;
    };

    Matrix.transformCoord = function (retVal, vec, mat) {
        var vX = vec[0];
        var vY = vec[1];
        var vZ = vec[2];
        var vW = mat[3] * vX + mat[7] * vY + mat[11] * vZ + mat[15];
        var invW = 1 / vW;

        var x = (mat[0] * vX + mat[4] * vY + mat[8] * vZ + mat[12]) * invW;
        var y = (mat[1] * vX + mat[5] * vY + mat[9] * vZ + mat[13]) * invW;
        var z = (mat[2] * vX + mat[6] * vY + mat[10] * vZ + mat[14]) * invW;

        retVal[0] = x;
        retVal[1] = y;
        retVal[2] = z;
        return retVal;
    };

    //-----------------------------------------------------------------------
    Matrix.toEulerAnglesZXY = function (result, matrix) {

        //   Radian& rfYAngle, Radian& rfPAngle, Radian& rfRAngle
        // rot =  cy*cz-sx*sy*sz -cx*sz           cz*sy+cy*sx*sz
        //        cz*sx*sy+cy*sz  cx*cz          -cy*cz*sx+sy*sz
        //       -cx*sy           sx              cx*cy

        result[1] = Math.asin(matrix[6]);
        if (result[1] < (Math.PI * 0.5)) {
            if (result[1] > (-Math.PI * 0.5)) {
                result[0] = Math.atan2(-matrix[4], matrix[5]);
                result[2] = Math.atan2(-matrix[2], matrix[10]);
                return true;
            }
            else {
                // WARNING.  Not a unique solution.
                var fRmY = Math.atan2(matrix[8], matrix[0]);
                result[2] = 0.0;  // any angle works
                result[0] = result[2] - fRmY;
                return false;
            }
        }
        else {
            // WARNING.  Not a unique solution.
            var fRpY = Math.atan2(matrix[8], matrix[0]);
            result[2] = 0.0;  // any angle works
            result[0] = fRpY - result[2];
            return false;
        }
    };



